"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = void 0;
const next_connect_1 = __importDefault(require("next-connect"));
const log = __importStar(require("next/dist/build/output/log"));
const context_1 = __importDefault(require("./context"));
const errors_1 = require("./errors");
const runtime_1 = __importDefault(require("./runtime"));
const onNoMatch = (req, res) => {
    res.setHeader('Allow', req.__allowed_methods.join(','));
    const err = new errors_1.MethodNotAllowedError();
    res.status(err.statusCode);
    return res.send(err.toJSON());
};
const onError = (err, req, res) => {
    if (!(err instanceof errors_1.APIError)) {
        log.error(err);
        err = new errors_1.InternalServerError();
    }
    res.status(err.statusCode);
    return res.send(err.toJSON());
};
const middlewareAction = (context, ware) => (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    return ware(context.attach({ req, res }), next);
});
const handle = (context, action, ...handlers) => {
    const handler = handlers.pop();
    return action(...handlers.map((ware) => middlewareAction(context, ware)), (req, res, next) => {
        return Promise.resolve(handler(context.attach({ req, res }), next)).then((body) => {
            if (body) {
                return res.send(body);
            }
        });
    });
};
const middleware = (context, use, ...wares) => {
    return use('', wares.map((ware) => middlewareAction(context, ware)));
};
const proxyHandler = {
    get(_, method) {
        const instance = (0, next_connect_1.default)({ onNoMatch, onError });
        const context = new context_1.default();
        instance.get = handle.bind(null, context, instance.get);
        instance.head = handle.bind(null, context, instance.head);
        instance.options = handle.bind(null, context, instance.options);
        instance.post = handle.bind(null, context, instance.post);
        instance.put = handle.bind(null, context, instance.put);
        instance.patch = handle.bind(null, context, instance.patch);
        instance.delete = handle.bind(null, context, instance.delete);
        instance.use((req, _, next) => {
            req.__allowed_methods = instance.routes
                .map((route) => route.method)
                .filter((r) => r.length);
            return next();
        });
        instance.use = middleware.bind(null, context, instance.use);
        return instance[method].bind(instance);
    },
};
exports.handler = new Proxy(runtime_1.default, proxyHandler);
exports.default = exports.handler;
//# sourceMappingURL=api-handler.js.map