import { ChangeEventHandler, FC, FocusEventHandler } from 'react';
import { Rule } from '../hooks/useForm';
export declare type FieldRenderProps<Value> = {
    name: string;
    id: string;
    type: InputProps['type'] | CheckboxProps['type'] | SelectProps['type'];
    value: Value;
    onChange: ChangeEventHandler<any>;
    onBlur: FocusEventHandler<any>;
};
export declare type CommonProps<Value> = {
    name: string;
    label?: string;
    className?: string;
    rules?: Rule[];
    value?: Value;
    render?: (props: FieldRenderProps<Value>, errors: null | string[]) => JSX.Element;
};
export declare type InputProps = CommonProps<string> & {
    type: 'text' | 'password' | 'email' | 'radio';
};
export declare type CheckboxProps = CommonProps<boolean> & {
    type: 'checkbox';
};
export declare type SelectOption = {
    label: string;
    value: string;
};
export declare type SelectProps = CommonProps<string> & {
    type: 'select';
    options: (SelectOption | string)[];
};
export declare type Props = InputProps | CheckboxProps | SelectProps;
export declare const Field: FC<Props>;
