"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Field = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const useForm_1 = require("../hooks/useForm");
const Field = ({ name, type, rules, className, label, value: defaultValue, options = [], render = renderer(type, label), }) => {
    if (type == 'checkbox' && typeof defaultValue === 'undefined') {
        defaultValue = false;
    }
    else if (type == 'select' && typeof defaultValue === 'undefined') {
        defaultValue = typeof options[0] === 'string' ? options[0] : options[0].value;
    }
    else if (typeof defaultValue === 'undefined') {
        defaultValue = '';
    }
    const { handleChange: onChange, handleBlur, value, errors } = (0, useForm_1.useField)({ name, value: defaultValue, rules });
    const handleChange = ({ target }) => {
        if (type === 'checkbox') {
            return onChange(target.checked);
        }
        if (type === 'radio') {
            return onChange(defaultValue);
        }
        return onChange(target.value);
    };
    if (typeof value !== 'undefined') {
        const props = {
            name,
            type,
            value,
            onChange: handleChange,
            onBlur: handleBlur,
        };
        if (type === 'select') {
            props.options = options.map((option) => {
                if (typeof option === 'string') {
                    return { label: option, value: option };
                }
                return option;
            });
        }
        if (render._default) {
            props.className = className;
        }
        return render(props, errors);
    }
    return null;
};
exports.Field = Field;
const renderer = (type, label) => {
    const genField = (_a) => {
        var { options = [] } = _a, props = __rest(_a, ["options"]);
        switch (type) {
            case 'select':
                return ((0, jsx_runtime_1.jsx)("select", Object.assign({}, props, { children: options.map(({ label, value }) => ((0, jsx_runtime_1.jsx)("option", { label: label, value: value }, label))) })));
            case 'checkbox':
            case 'text':
            case 'password':
            case 'email':
            case 'radio':
            default:
                return (0, jsx_runtime_1.jsx)("input", Object.assign({ type: type }, props));
        }
    };
    const fn = (props) => {
        if (label) {
            return ((0, jsx_runtime_1.jsxs)("div", { children: [type !== 'checkbox' && (0, jsx_runtime_1.jsx)("label", Object.assign({ htmlFor: props.name }, { children: label })), genField(props), type === 'checkbox' && (0, jsx_runtime_1.jsx)("label", Object.assign({ htmlFor: props.name }, { children: label }))] }));
        }
        return genField(props);
    };
    fn._default = true;
    return fn;
};
//# sourceMappingURL=Field.js.map