export declare type Address = {
    name: string;
    address: string;
};
export declare type Recipient = string | string[] | Address | Address[];
export declare type SendParams<Values = Record<string, any>> = {
    template: string;
    values?: Values;
    subject: string;
    from?: Recipient;
    to: Recipient;
    cc?: Recipient;
    replyTo?: Recipient;
};
export declare const send: <Values>({ template, values, from, ...envelope }: SendParams<Values>) => Promise<import("nodemailer/lib/smtp-transport").SentMessageInfo>;
