import { InferGetServerSidePropsType } from 'next';
import { MaybePromise, RequestBody, RuntimeContext } from 'next-runtime';
import { ParsedUrlQuery } from 'next-runtime/types/querystring';
export declare type InferProps<T> = InferGetServerSidePropsType<T>;
export declare type Loader<Props extends {} = {}, Params extends {} = {}> = (context: RuntimeContext<Params>) => MaybePromise<Props>;
export declare type Action<Props extends {} = {}, Body extends {} = {}, Params extends {} = {}> = (context: RuntimeContext<Params> & RequestBody<Body>) => MaybePromise<Props>;
export declare type Runtime<Props, Query, Body> = {
    loader?: Loader<Props, Query>;
    action?: Action<Props, Body, Query>;
};
export declare type Handlers = {
    loader?: Function;
    action?: Function;
};
export declare const notFound: (headers?: Record<string, string | number>) => never;
export declare const redirect: (destination: string, status?: number | {
    statusCode?: number;
    headers?: Record<string, string | number>;
}) => never;
declare const _default: (handlers: Handlers) => import("next").GetServerSideProps<{
    [key: string]: any;
}, ParsedUrlQuery, import("next").PreviewData>;
export default _default;
